<template>
  <v-menu
    v-model="menuDisplay"
    :close-on-content-click="false"
    :disabled="disable"
  >
    <template #activator="{ props, isActive }">
      <v-text-field
        :model-value="date ? formatDate(modelValue, 'DD/MM/YYYY') : null"
        v-bind="props"
        readonly
        append-inner-icon="mdi-calendar"
        clearable=""
        class="w-full"
        :class="inputClass"
        :base-color="baseColor"
        :density="density"
        :variant="variant"
        :error="error"
        hide-details
        :label="label"
        :placeholder="placeholder"
        @click:clear="clear()"
      />
    </template>

    <v-date-picker
      v-model="date"
      :title="title"
      class="w-full"
      input-mode="calendar"
      :disabled="disable"
      hide-actions
      @update:model-value="change"
    >
      <template #header>
        <div class="px-2">
          <v-btn
            :text="headerText"
            variant="text"
            color="primary"
            class="normal-case"
            :disabled="!date"
            @click="clear"
          />
        </div>
      </template>
    </v-date-picker>
  </v-menu>
</template>
<script setup>
import { ref, watch, onMounted } from "vue";
import moment from "moment";

onMounted(() => {
  if (props?.modelValue) {
    date.value = new Date(props?.modelValue);
  }
});

const emit = defineEmits(['update:modelValue'])

const date = ref(null);
const menuDisplay = ref(false);

const props = defineProps({
  modelValue: { type: String, default: "" },
  disable: { type: Boolean, default: false },
  error: { type: Boolean, default: false },
  label: { type: String, default: null },
  placeholder: { type: String, default: null },
  density: {type: String, default: 'compact'},
  inputClass: { type: String, default: null },
  title: { type: String, default: 'Select a date'},
  headerText: { type: String, default: 'Clear selected date'},
  variant: { type: String, default: 'outlined' },
  baseColor: { type: String, default: 'middleGrey' },
})

const change = (e) => {
  emit('update:modelValue', new Date(date.value).toLocaleDateString('fr-CA'))
  menuDisplay.value = false
}

const clear = () => {
  date.value = null
  emit('update:modelValue', null)
  menuDisplay.value = false
}

const formatDate = (value, formatStr = "DD MMM, YYYY", initialFormatStr = "YYYY-MM-DD HH:mm:ss [UTC]" ) => {
  if (!value || value.length === 0)
    return "Invalid date"
  if (typeof value === 'number')
    return moment(value).format(formatStr)
  if (value.split('/').length === 3) {
    return moment(value, "DD/MM/YYYY").format(formatStr)
  } else if (value.split('T').length === 2) {
    return moment(value.split('T')[0], "YYYY-MM-DD").format(formatStr)
  } else if (value.includes('UTC') || value.includes('+')) {
    return moment(value, initialFormatStr).format(formatStr)
  } else if (value.split('-').length === 3) {
    return moment(value).format(formatStr)
  }
}

watch(props, (newValue, oldValue) => {
  if (newValue.modelValue) {
    date.value = new Date(newValue.modelValue);
  }
})
</script>

<style scoped>
* :deep(.v-field) {
  border-radius: 8px;
}
</style>
